import 'package:flutter/material.dart';

import 'package:selectdropdown/dropDownForm.dart';

import 'package:selectdropdown/dropDownItem.dart';

import 'package:selectdropdown/selectdropdown.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Select Drop Down',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(),
    );
  }
}

class MyHomePage extends StatefulWidget {
  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  List<DropDownForm> dropDownList = [
    DropDownForm(id: 01, display: 'Chhany'),
    DropDownForm(id: 02, display: 'Chhunleang'),
  ];
  final String purposeLabel = "";

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Custom Drop Down'),
      ),
      body: Center(
        child: CustomDropDown(
          defaultValue: {'Name': 'my name', 'Code': '02'},
          item: dropDownList.asMap().entries.map((e) {
            return DropDownItem(
              itemList: {
                "Name": e.value.display,
                "Code": e.value.id.toString()
              },
            );
          }).toList(),
          onChange: (v) {
            setState(() {
              DropDownForm(id: int.parse(v["Code"]), display: v["Name"]);
            });
          },
          label: 'select something...',
        ),
      ),
    );
  }
}
