import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

openDateTimePicker(
    {BuildContext context,
    ValueChanged<String> onChange,
    DateTime selectedDate}) {
  return showModalBottomSheet(
      builder: (BuildContext context) {
        return Container(
          height: 250,
          child: Column(
            children: [
              Container(
                margin: EdgeInsets.symmetric(vertical: 0),
                height: 50,
                width: double.infinity,
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    FlatButton(
                      splashColor: Colors.transparent,
                      child: Text(
                        'Cancel',
                        style: Theme.of(context).textTheme.bodyText1,
                      ),
                      onPressed: () {
                        Navigator.pop(context);
                      },
                    ),
                    FlatButton(
                      splashColor: Colors.transparent,
                      child: Text(
                        'Done',
                        style: Theme.of(context).textTheme.headline3,
                      ),
                      onPressed: () {
                        Navigator.pop(context);
                      },
                    )
                  ],
                ),
              ),
              Expanded(
                child: CupertinoDatePicker(
                  mode: CupertinoDatePickerMode.date,
                  initialDateTime:
                      selectedDate != null ? selectedDate : DateTime.now(),
                  onDateTimeChanged: (DateTime value) {
                    String dateofbirth =
                        DateFormat("yyyy-MM-dd", 'en').format(value);
                    onChange(dateofbirth);
                  },
                ),
              ),
            ],
          ),
        );
      },
      context: context);
}
