import 'package:flutter/material.dart';
import 'package:selectdropdown/dateTimePicker.dart';

import 'package:selectdropdown/dropDownItem.dart';

class CustomDropDown extends StatefulWidget {
  List<DropDownItem> item;
  String label;
  ValueChanged<Map> onChange;
  bool validate = false;
  Map defaultValue;
  bool isDateTimePicker = false;
  bool isValidate;
  bool isSelectMember;
  CustomDropDown(
      {Key key,
      this.item,
      this.onChange,
      this.label,
      this.validate,
      this.isDateTimePicker,
      this.defaultValue,
      this.isSelectMember = false,
      this.isValidate})
      : super(key: key);
  @override
  @override
  _CustomDropDownState createState() => _CustomDropDownState();
}

class _CustomDropDownState extends State<CustomDropDown> {
  Map selectData = {};
  Map copyData = {};
  int currentIndex;
  String dateTime;
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: widget.isDateTimePicker != null && widget.isDateTimePicker
          ? () {
              openDateTimePicker(
                  context: context,
                  onChange: (value) {
                    setState(() {
                      copyData = {
                        'Name': value,
                        'Code': '01',
                      };
                    });
                    widget.onChange({
                      'Name': value,
                      'Code': '01',
                    });
                  },
                  selectedDate: DateTime.now());
            }
          : () async {
              showModalBottomSheet(
                backgroundColor: Colors.transparent,
                context: context,
                builder: (context) {
                  return ClipRRect(
                    borderRadius: BorderRadius.only(
                        topLeft: Radius.circular(20),
                        topRight: Radius.circular(20)),
                    child: Container(
                      width: double.infinity,
                      height: double.infinity,
                      color: Theme.of(context).cardColor,
                      child: Stack(
                        alignment: Alignment.topCenter,
                        children: [
                          Container(
                            margin: EdgeInsets.only(top: 10),
                            height: 5,
                            width: 30,
                            color: Colors.grey[300],
                          ),
                          Positioned(
                            top: 20,
                            left: 20,
                            right: 20,
                            bottom: 0,
                            child: ListView.separated(
                              separatorBuilder: (context, index) {
                                return Divider();
                              },
                              itemBuilder: (context, index) {
                                return InkWell(
                                  onTap: () {
                                    Navigator.pop(context);
                                    widget
                                        .onChange(widget.item[index].itemList);
                                    setState(() {
                                      currentIndex = index;

                                      copyData = {
                                        'Name':
                                            widget.item[index].itemList['Name'],
                                        'Code':
                                            widget.item[index].itemList['Code'],
                                      };
                                    });
                                  },
                                  child: DropDownItem(
                                    isSelect: currentIndex == index,
                                    itemList: {
                                      'Name':
                                          widget.item[index].itemList['Name'],
                                      'Code':
                                          widget.item[index].itemList['Code'],
                                    },
                                  ),
                                );
                              },
                              itemCount: widget.item.length,
                            ),
                          ),
                        ],
                      ),
                    ),
                  );
                },
              );
            },
      child: Container(
        height: widget.isValidate != null && !widget.isValidate ? 90 : 60,
        // color: Theme.of(context).cardColor,
        child: Stack(
          children: [
            widget.isValidate != null && !widget.isValidate
                ? Container(
                    // color: Theme.of(context).cardColor,
                    height: 60,
                    width: double.infinity,
                    child: Stack(
                      children: [
                        Container(
                          height: double.infinity,
                          width: double.infinity,
                        ),
                        Positioned(
                          top: 10,
                          left: 0,
                          right: 0,
                          bottom: 0,
                          child: Container(
                            margin: EdgeInsets.symmetric(
                                horizontal: 20, vertical: 0),
                            alignment: Alignment.centerLeft,
                            height: 50,
                            width: double.infinity,
                            padding: EdgeInsets.symmetric(
                                horizontal: 20, vertical: 10),
                            decoration: BoxDecoration(
                                color: copyData == selectData
                                    ? Colors.grey[100]
                                    : Theme.of(context).cardColor,
                                borderRadius: BorderRadius.circular(10),
                                border: Border.all(color: Colors.red)),
                            child: Row(
                              children: [
                                Text(copyData['Name'],
                                    style: copyData == selectData
                                        ? Theme.of(context).textTheme.bodyText2
                                        : Theme.of(context)
                                            .textTheme
                                            .bodyText2),
                                Spacer(),
                                widget.isDateTimePicker != null &&
                                        widget.isDateTimePicker
                                    ? Icon(
                                        Icons.date_range_sharp,
                                        color: copyData != selectData
                                            ? Theme.of(context).primaryColor
                                            : Colors.black,
                                      )
                                    : Icon(
                                        Icons.arrow_drop_down,
                                        color: copyData != selectData
                                            ? Theme.of(context).primaryColor
                                            : Colors.black,
                                      )
                              ],
                            ),
                          ),
                        ),
                        if (copyData != selectData)
                          Positioned(
                            top: 5,
                            left: 35,
                            child: Container(
                              color: Theme.of(context).cardColor,
                              padding: EdgeInsets.symmetric(horizontal: 5),
                              child: Text(
                                widget.label,
                                style: TextStyle(
                                  color: Colors.black,
                                  fontSize: 9,
                                  fontWeight: FontWeight.w100,
                                  fontFamily: 'DMSans',
                                ),
                              ),
                            ),
                          ),
                      ],
                    ),
                  )
                : Container(
                    height: 60,
                    width: double.infinity,
                    child: Stack(
                      children: [
                        Container(
                          height: double.infinity,
                          width: double.infinity,
                        ),
                        Positioned(
                          top: 10,
                          left: 0,
                          right: 0,
                          bottom: 0,
                          child: Container(
                            margin: EdgeInsets.symmetric(
                                horizontal: 20, vertical: 0),
                            alignment: Alignment.centerLeft,
                            height: 50,
                            width: double.infinity,
                            padding: EdgeInsets.symmetric(
                                horizontal: 20, vertical: 10),
                            decoration: BoxDecoration(
                                color: copyData == selectData
                                    ? Colors.grey[100]
                                    : Theme.of(context).cardColor,
                                borderRadius: BorderRadius.circular(10),
                                border: copyData == selectData
                                    ? null
                                    : Border.all(color: Colors.grey)),
                            child: Row(
                              children: [
                                Text(
                                  "${copyData['Name']}",
                                  style: copyData == selectData
                                      ? Theme.of(context).textTheme.bodyText2
                                      : Theme.of(context).textTheme.bodyText2,
                                ),
                                Spacer(),
                                widget.isDateTimePicker != null &&
                                        widget.isDateTimePicker
                                    ? Icon(
                                        Icons.date_range_sharp,
                                        color: copyData != selectData
                                            ? Theme.of(context).primaryColor
                                            : Colors.black,
                                      )
                                    : Icon(
                                        Icons.arrow_drop_down,
                                        color: copyData != selectData
                                            ? Theme.of(context).primaryColor
                                            : Colors.black,
                                      )
                              ],
                            ),
                          ),
                        ),
                        if (copyData != selectData)
                          Positioned(
                            top: 5,
                            left: 35,
                            child: Container(
                              color: Theme.of(context).cardColor,
                              padding: EdgeInsets.symmetric(horizontal: 5),
                              child: Text(
                                widget.label,
                                style: TextStyle(
                                  color: Colors.black,
                                  fontSize: 9,
                                  fontWeight: FontWeight.w100,
                                  fontFamily: 'DMSans',
                                ),
                              ),
                            ),
                          ),
                      ],
                    ),
                  ),
            widget.isValidate != null && !widget.isValidate
                ? Positioned(
                    left: 20,
                    top: 70,
                    right: 0,
                    bottom: 0,
                    child: Row(
                      children: [
                        Icon(
                          Icons.error,
                          color: Colors.red,
                          size: 20,
                        ),
                        SizedBox(
                          width: 10,
                        ),
                        Text(
                          'Please enter your ',
                          style: TextStyle(
                              color: Colors.red,
                              fontSize: 12,
                              fontFamily: 'DMSans'),
                        ),
                      ],
                    ),
                  )
                : Container(),
          ],
        ),
      ),
    );
  }
}
